SystemOrganization addCategory: #'LizViz-Traits'!

Trait named: #TZzAddFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:43:55.366'!
add: anItemValue
	
	^ self addFirst: anItemValue! !

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:47:19.067'!
addFirst: anItemValue
	
	| newItem |
	newItem := ZzDoubleLinkedListItem new
		nextItem: self firstItem;
		previousItem: nil;
		value: anItemValue.
	self firstItem: newItem.
	self firstItem nextItem ifNotNilDo: [:item | item previousItem: newItem].
	^ newItem! !

Trait named: #TZzAddLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddLastOperation methodsFor: 'as yet unclassified' stamp: 'ls 6/5/2013 14:18:38.772'!
addLast: anItemValue
	
	| lastItem newItem |
	newItem := ZzDoubleLinkedListItem new
		nextItem: nil;
		previousItem: nil;
		value: anItemValue.
	
	self firstItem ifNil: [self firstItem: newItem. ^ newItem].
	
	lastItem := self firstItem.
	(lastItem isNil not and: [lastItem nextItem isNil not])
		whileTrue: [lastItem := lastItem nextItem].
	newItem previousItem: lastItem.
	lastItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzIsEmptyOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzIsEmptyOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:48:15.168'!
isEmpty
	
	^ self firstItem isNil! !

Trait named: #TZzRemoveFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:51:59.785'!
removeFirst
	
	self firstItem ifNil: [^ self].
	self firstItem: self firstItem nextItem.
	self firstItem previousItem: nil.! !

Trait named: #TZzSizeOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzSizeOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:24:11.643'!
size
	
	| size nextItem |
	size := 0.
	nextItem := self firstItem.
	nextItem isNil not whileTrue: 
		[size := size + 1.
		nextItem := nextItem nextItem].
	^ size! !
